class Cedge : public Cobject {
public:
	static Cedge *g_hash[HASHSIZE];
	static int	 g_hash_cnt;

	Cedge			*m_hashP;
	Cfile			*m_fileP;
	int				m_lineno;
	Cfunction		*m_fromP;
	Cclassmember	*m_toP;		/* Function->function or Function->variable */
	unsigned int	m_freq;

	static unsigned int hash(const Cfunction *fromP, const Cclassmember *toP);
	Cedge(Cfunction *fromP, Cclassmember *toP, int lineno, Cfile *fileP);
	static Cedge *locate(Cfunction *fromP, Cclassmember *toP, int lineno, Cfile *fileP);
	void resolve(void);

	const char *	get_type(void) const;

	virtual objectE	type(void) const;
	virtual void	emit_id(void) const;
	virtual void	print(void) const;
	virtual void	emit_edges(void);

	void			emit_attributes(void) const;
};
