#include <assert.h>
#include <malloc.h>
#include <string.h>
#include <stdio.h>
#include "util.h"
#include "object.h"

// #define SANITY

Cobject	*Cobject::g_created_headP = 0;
Cobject	*Cobject::g_created_tailP = 0;
int		Cobject::g_cnt            = 0;

void
Cobject::add_created()
{
	assert(m_created_nextP == (Cobject *) -1);
	m_created_nextP = 0;
	if (!g_created_headP) {
		g_created_headP = this;
	} else {
		g_created_tailP->m_created_nextP = this;
	}
	g_created_tailP = this;
	++g_cnt;
}

Cobject::Cobject(void)
{
#ifdef SANITY
	extern void sanity();

	sanity();
#endif

	m_created_nextP = (Cobject *) -1;
}

Centity::Centity(void)
{
	m_parentP       = 0;
	m_nameP         = 0;
}

void
Centity::name(const char *nameP)
{
	if (m_nameP) {
		free(m_nameP);
		m_nameP = 0;
	}
	if (nameP) {
		m_nameP = (char *) malloc(strlen(nameP) + 1);
		if (!m_nameP) {
			outofmemory();
		}
		strcpy(m_nameP, nameP);
		return;
	}
}

int
Centity::full_path(char *bufferP) const
{
	int	lth;

	if (m_parentP) {
		lth = m_parentP->full_path(bufferP);
	} else {
		lth = 0;
	}
	return(lth);
}

/* virtual */ void
Centity::emit_edges(void)
{
	if (m_parentP) {
		fputs("contain ", stdout);
		m_parentP->emit_id();
		fputc(' ', stdout);
		emit_id();
		fputc('\n', stdout);
}	}

Centity::~Centity(void)
{
	free(m_nameP);
}
