typedef enum {
	entityE    = 0,	
	directoryE = 1,
	archiveE   = 2,
	sourceE    = 3,
	unitE      = 4,
    fileE      = 5,
	functionE  = 6,
	variableE  = 7,
	edgeE      = 8,
	classE     = 9
} objectE;

class Cobject {
public:
	static Cobject	*g_created_headP;
	static Cobject	*g_created_tailP;
	static int		g_cnt;

	Cobject			*m_created_nextP;		/* List in the order created */

	Cobject(void);

	void add_created(void);

	virtual void 	emit_id(void) const   = 0;
	virtual objectE	type(void) const      = 0;
	virtual void	print(void) const     = 0;
	virtual void	emit_edges(void)      = 0;
};

class Centity : public Cobject {
public:
	Centity	*m_parentP;
	char	*m_nameP;

	Centity(void);
	~Centity(void);

	void			name(const char *nameP);
	void			add_class(void) const;
	virtual void	emit_edges(void);
	virtual int		full_path(char *bufferP) const;
};

